import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "igniteui-react-core";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-react-core";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { Size } from "igniteui-react-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-react-core";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected cq(): SeriesView;
    oz(): void;
    qw(a: SeriesView): void;
    yo: ScatterBaseView;
    protected get_fu(): boolean;
    ai(): Axis[];
    ko(a: any, b: string): any;
    ma(a: string): string;
    d9(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    protected b0(): SeriesHitTestMode;
    wi(a: Point): Rect;
    gu(a: Point, b: boolean): boolean;
    constructor();
    yn: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    aak: string;
    get y8(): IFastItemColumn$1<number>;
    set y8(a: IFastItemColumn$1<number>);
    private y6;
    aas: string;
    get y9(): IFastItemColumn$1<number>;
    set y9(a: IFastItemColumn$1<number>);
    private y7;
    z4: string;
    z6: string;
    protected f9(): boolean;
    protected zn(): boolean;
    protected hr(): List$1<SeriesLayerPropertyOverlay>;
    private aay;
    private aaz;
    aag: string;
    aao: string;
    aai: string;
    aaq: string;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get ab8(): Brush;
    set ab8(a: Brush);
    static readonly abj: DependencyProperty;
    trendLineThickness: number;
    aca: PenLineCap;
    ab9: DoubleCollection;
    trendLinePeriod: number;
    yk: CollisionAvoidanceType;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    z1: number;
    z0: number;
    yz: ScatterItemSearchMode;
    zz: number;
    p5(): void;
    yp: ScatterErrorBarSettings;
    protected q4(a: any, b: string, c: any, d: any): void;
    protected zk(): boolean;
    protected zj(): boolean;
    ze(a: any): boolean;
    zd(a: any): boolean;
    private abh;
    private acb;
    private acc;
    private aau;
    protected zi(a: string, b: FastItemsSourceEventAction): boolean;
    protected o8(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    aa8(a: ScatterFrame): void;
    aa9(a: ScatterFrame, b: Clipper): void;
    ax(a: Axis): AxisRange;
    kl(a: Point): any;
    private yw;
    get yx(): ScatterItemSearchMode;
    set yx(a: ScatterItemSearchMode);
    protected yy(): ScatterItemSearchMode;
    j1(a: Point): number;
    ip(a: Point): number;
    protected zv(a: Point): number;
    private yd;
    private ye;
    protected zu(a: Point): number;
    private aax;
    protected get_zh(): boolean;
    protected get zh(): boolean;
    private zy;
    protected zx(a: Point): number;
    protected zt(a: Point): number;
    protected zw(a: Point): number;
    v5(a: Point, b: boolean, c: boolean): Point;
    gb(a: any): boolean;
    protected sj(a: Rect, b: Rect): void;
    protected sk(a: Rect, b: Rect): void;
    yt: ScatterFrame;
    yv: ScatterFrame;
    yr: ScatterFrame;
    ys(): ScatterFrame;
    aav(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    aa5(a: ScatterFrame, b: ScatterBaseView): void;
    o2(a: boolean, b: SeriesView): void;
    zg: boolean;
    zf: boolean;
    protected zc: boolean;
    protected zb: boolean;
    protected get_fc(): boolean;
    private y4;
    private y5;
    protected y2(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected y3(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    wm(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected y1(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    de(a: any, b: Point, c: boolean): HighlightingInfo;
    df(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    protected zm(): boolean;
    protected zl(): boolean;
    abg(a: ScatterFrame, b: ScatterBaseView): void;
    yg(a: number, b: number): any[];
    protected yh(a: number, b: number): any[];
    protected y0: ScatterSeriesRenderManager;
    aaw(a: ScatterBaseView, b: ScatterFrame): void;
    protected aa1(a: number, b: number, c: boolean): void;
    protected aa0(a: number, b: number, c: boolean): void;
    protected abb(a: AssigningScatterStyleEventArgs): void;
    protected aba(a: AssigningScatterMarkerStyleEventArgs): void;
    aa3(a: ScatterFrame, b: ScatterBaseView): void;
    aa6(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    aa4(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    aa2(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    aa7(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    abd(a: ScatterFrame, b: ScatterBaseView): void;
    private abe;
    private abf;
    hc(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    rn(a: boolean): void;
    protected sa(): void;
    yu: ScatterFrame;
    ro(a: Rect, b: RenderSurface): void;
    private yq;
    rl(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    abc(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    yf(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    zo(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected pu(a: any): void;
    iw(): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    private za;
    private zp;
    private zq;
    zr: number;
    zs: number;
    private abi;
    i6(a: ValueLayerValueMode, b: Axis): number;
    ap(a: ValueLayerValueMode): number[];
    v9(a: number[]): Point;
    v8(a: ValueLayerValueMode): Point;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    aw: AssigningScatterMarkerStyleEventArgs;
    ax: AssigningScatterStyleEventArgs;
    ay(a: ScatterBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    a0(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    c0: MarkerManagerBase;
    protected cy: Point[];
    protected c1: ScatterBase;
    protected c6: List$1<number>;
    constructor(a: ScatterBase);
    private dh;
    private di;
    c2: ScatterTrendLineManager;
    au(): void;
    private dg;
    dj(a: Marker): Size;
    protected cz(): MarkerManagerBase;
    protected de(a: IDictionary$2<any, OwnedPoint>): void;
    c5(): List$1<Marker>;
    cx(): Point[];
    protected cw(): Point[];
    protected c4(): List$1<number>;
    c7(): void;
    dc(a: PathGeometry): void;
    c8(): void;
    dd(a: PathGeometry): void;
    df(): void;
    c3: HashPool$2<any, Marker>;
    cj(a: (arg1: Marker) => void): void;
    da(a: (arg1: Marker) => void): void;
    db(): void;
    protected a7(a: RenderingContext, b: boolean): void;
    c9(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
